import { useEffect, useRef } from 'react';
var useMutationObserver = function useMutationObserver(callback, options) {
  if (options === void 0) {
    options = {
      attributes: true,
      characterData: true,
      childList: true,
      subtree: true
    };
  }
  var ref = useRef();
  useEffect(function () {
    if (ref.current) {
      var observer = new MutationObserver(callback.bind(null, ref.current));
      observer.observe(ref.current, options);
      return function () {
        return observer.disconnect();
      };
    }
  }, [callback, options]);
  return [ref];
};
export default useMutationObserver;